# coding: utf-8

"""
    URL Shortener API

    This API is responsible of authetication and the creation, modification and deletion of uris and hooks.  # noqa: E501

    OpenAPI spec version: 1.0.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six


class HookActionMail(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'destinations': 'list[str]',
        'subject': 'str',
        'text': 'str'
    }

    attribute_map = {
        'destinations': 'destinations',
        'subject': 'subject',
        'text': 'text'
    }

    def __init__(self, destinations=None, subject=None, text=None):  # noqa: E501
        """HookActionMail - a model defined in Swagger"""  # noqa: E501
        self._destinations = None
        self._subject = None
        self._text = None
        self.discriminator = None
        if destinations is not None:
            self.destinations = destinations
        if subject is not None:
            self.subject = subject
        if text is not None:
            self.text = text

    @property
    def destinations(self):
        """Gets the destinations of this HookActionMail.  # noqa: E501


        :return: The destinations of this HookActionMail.  # noqa: E501
        :rtype: list[str]
        """
        return self._destinations

    @destinations.setter
    def destinations(self, destinations):
        """Sets the destinations of this HookActionMail.


        :param destinations: The destinations of this HookActionMail.  # noqa: E501
        :type: list[str]
        """

        self._destinations = destinations

    @property
    def subject(self):
        """Gets the subject of this HookActionMail.  # noqa: E501


        :return: The subject of this HookActionMail.  # noqa: E501
        :rtype: str
        """
        return self._subject

    @subject.setter
    def subject(self, subject):
        """Sets the subject of this HookActionMail.


        :param subject: The subject of this HookActionMail.  # noqa: E501
        :type: str
        """

        self._subject = subject

    @property
    def text(self):
        """Gets the text of this HookActionMail.  # noqa: E501


        :return: The text of this HookActionMail.  # noqa: E501
        :rtype: str
        """
        return self._text

    @text.setter
    def text(self, text):
        """Sets the text of this HookActionMail.


        :param text: The text of this HookActionMail.  # noqa: E501
        :type: str
        """

        self._text = text

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(HookActionMail, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, HookActionMail):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
